function varargout = boltzmann(varargin)
% BOLTZMANN M-file for boltzmann.fig
%      BOLTZMANN, by itself, creates a new BOLTZMANN or raises the existing
%      singleton*.
%
%      H = BOLTZMANN returns the handle to a new BOLTZMANN or the handle to
%      the existing singleton*.
%
%      BOLTZMANN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BOLTZMANN.M with the given input arguments.
%
%      BOLTZMANN('Property','Value',...) creates a new BOLTZMANN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before boltzmann_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to boltzmann_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help boltzmann

% Last Modified by GUIDE v2.5 16-Mar-2010 14:01:21

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @boltzmann_OpeningFcn, ...
                   'gui_OutputFcn',  @boltzmann_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before boltzmann is made visible.
function boltzmann_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to boltzmann (see VARARGIN)

% Choose default command line output for boltzmann
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% Display program info message
uiwait(msgbox('Boltzmann & Heat Exchange 1.0 by Kristofer Modig (2010).',...
    'Proginfo','modal'));

% This sets up the initial plot - only do when we are invisible
% so window can get raised using boltzmann.
if strcmp(get(hObject,'Visible'),'off')
    calculate_ElevelsA(handles);
    calculate_ElevelsB(handles);
    TsliderA_Callback(handles.TsliderA, eventdata, handles);
    TsliderB_Callback(handles.TsliderB, eventdata, handles);
end


% UIWAIT makes boltzmann wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = boltzmann_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)


% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)



%% --- Executes on slider movement.
function TsliderA_Callback(hObject, eventdata, handles)
% hObject    handle to TsliderA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Make sure temperature is an integer
%set(hObject,'Value',round(get(hObject,'Value')));
set(handles.TstringA,'String',sprintf('%.1f K',get(hObject,'Value')));
T = get(hObject,'Value');

% Get energy levels and their degenaracies from axes data
M = get(handles.figure1,'UserData');
Ediff = M.A.Ei(2)-M.A.Ei(1);
Elev = M.A.Ei;
gi = M.A.gi;

% Calculate partition function and populations
[p, q] = boltzfun(T,Elev,gi);
if T == 0,
    p(1) = 1;
    q = 1;
end
set(handles.particQ,'String',num2str(q));

axes(handles.axesA);
cla;

% First plot energy levels
yMax = str2num(get(handles.ymaxA,'String'));
LEV = [Elev(Elev <= yMax)' Elev(Elev <= yMax)'];
if get(handles.showLevelsA,'Value') == 1
    plot(LEV',[0 1]','k:','LineWidth',0.2);
    hold on
end
if T == 0,
    Eplot = Elev(Elev <= yMax);
    pplot = zeros(size(Eplot));
    pplot(1) = 1;
else
    Eplot = Elev(1:size(LEV,1));
    pplot = p(1:size(LEV,1));
    %pplot = p;
    %Eplot = Elev(1:length(pplot));
end
if get(handles.pRelativeA,'Value') == 1
    pplot = pplot/pplot(1);
end
bar(Eplot+Ediff/3,pplot,0.6);
ylim([0 str2num(get(handles.xmaxA,'String'))]);
xlim([min(Elev) yMax+Ediff]);
ylabel('Population');
xlabel('Energy (E_i/k) / K^{-1}');
set(handles.axesA,'view',[270 90],'ydir','reverse','TickDir','out');
hold off
drawnow;

% Calcuate entropy per particle
Elev = Elev(p>0);
p = p(p>0);
particS = -sum(p.*log(p));
set(handles.particS,'String',sprintf('%.4f',particS));
set(handles.molarS,'String',sprintf('%.4f',8.3145*particS));
set(handles.totalS,'String',sprintf('%.4f',...
    str2num(get(handles.NparticlesA,'String'))*8.3145*particS));
% Calcuate energy per particle
particU = sum(Elev.*p);
set(handles.particU,'String',sprintf('%.2f',particU));
set(handles.molarU,'String',sprintf('%.5f',8.3145*particU/1000));
set(handles.totalU,'String',sprintf('%.5f',...
    str2num(get(handles.NparticlesA,'String'))*8.3145*particU/1000));

% Calculate and set total entropy
Stot = str2num(get(handles.NparticlesA,'String'))*8.3145*particS+...
    str2num(get(handles.totalSB,'String'));
set(handles.totalStot,'String',sprintf('%.4f',Stot));


%% --- Executes during object creation, after setting all properties.
function TsliderA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TsliderA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%% --- Executes on slider movement.
function TsliderB_Callback(hObject, eventdata, handles)
% hObject    handle to TsliderB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Make sure temperature is an integer
%set(hObject,'Value',round(get(hObject,'Value')));
set(handles.TstringB,'String',sprintf('%.1f K',get(hObject,'Value')));
T = get(hObject,'Value');

% Get energy levels and their degenaracies from axes data
M = get(handles.figure1,'UserData');
Ediff = M.B.Ei(2)-M.B.Ei(1);
Elev = M.B.Ei;
gi = M.B.gi;

% Calculate partition function and populations
[p, q] = boltzfun(T,Elev,gi);
if T == 0,
    p(1) = 1;
    q = 1;
end
set(handles.particQB,'String',num2str(q));

axes(handles.axesB);
cla;

% First plot energy levels
yMax = str2num(get(handles.ymaxB,'String'));
LEV = [Elev(Elev <= yMax)' Elev(Elev <= yMax)'];
if get(handles.showLevelsB,'Value') == 1
    plot(LEV',[0 1]','k:','LineWidth',0.2);
    hold on
end
if T == 0,
    Eplot = Elev(Elev <= yMax);
    pplot = zeros(size(Eplot));
    pplot(1) = 1;
else
    Eplot = Elev(1:size(LEV,1));
    pplot = p(1:size(LEV,1));
    %pplot = p;
    %Eplot = Elev(1:length(pplot));
end
if get(handles.pRelativeB,'Value') == 1
    pplot = pplot/pplot(1);
end
bar(Eplot+Ediff/3,pplot,0.6);
ylim([0 str2num(get(handles.xmaxB,'String'))]);
xlim([min(Elev) yMax+Ediff]);
ylabel('Population');
xlabel('Energy (E_i/k) / K^{-1}');
set(handles.axesB,'view',[270 90],'ydir','reverse','TickDir','out');
hold off
drawnow;

% Calcuate entropy per particle
Elev = Elev(p>0);
p = p(p>0);
particS = -sum(p.*log(p));
set(handles.particSB,'String',sprintf('%.4f',particS));
set(handles.molarSB,'String',sprintf('%.4f',8.3145*particS));
set(handles.totalSB,'String',sprintf('%.4f',...
    str2num(get(handles.NparticlesB,'String'))*8.3145*particS));
% Calcuate energy per particle
particU = sum(Elev.*p);
set(handles.particUB,'String',sprintf('%.2f',particU));
set(handles.molarUB,'String',sprintf('%.5f',8.3145*particU/1000));
set(handles.totalUB,'String',sprintf('%.5f',...
    str2num(get(handles.NparticlesB,'String'))*8.3145*particU/1000));

% Calculate and set total entropy
Stot = str2num(get(handles.totalS,'String'))+...
    str2num(get(handles.NparticlesB,'String'))*8.3145*particS;
set(handles.totalStot,'String',sprintf('%.4f',Stot));


%% --- Executes during object creation, after setting all properties.
function TsliderB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TsliderB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function ymaxA_Callback(hObject, eventdata, handles)
% hObject    handle to ymaxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ymaxA as text
%        str2double(get(hObject,'String')) returns contents of ymaxA as a double
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function ymaxA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ymaxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function EdiffA_Callback(hObject, eventdata, handles)
% hObject    handle to EdiffA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of EdiffA as text
%        str2double(get(hObject,'String')) returns contents of EdiffA as a double
calculate_ElevelsA(handles);
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function EdiffA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdiffA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NparticlesA_Callback(hObject, eventdata, handles)
% hObject    handle to NparticlesA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NparticlesA as text
%        str2double(get(hObject,'String')) returns contents of NparticlesA as a double
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function NparticlesA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NparticlesA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function xmaxA_Callback(hObject, eventdata, handles)
% hObject    handle to xmaxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of xmaxA as text
%        str2double(get(hObject,'String')) returns contents of xmaxA as a double
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function xmaxA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to xmaxA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ymaxB_Callback(hObject, eventdata, handles)
% hObject    handle to ymaxB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ymaxB as text
%        str2double(get(hObject,'String')) returns contents of ymaxB as a double
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function ymaxB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ymaxB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%
function EdiffB_Callback(hObject, eventdata, handles)
% hObject    handle to EdiffB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of EdiffB as text
%        str2double(get(hObject,'String')) returns contents of EdiffB as a double
calculate_ElevelsB(handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function EdiffB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdiffB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%
function NparticlesB_Callback(hObject, eventdata, handles)
% hObject    handle to NparticlesB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NparticlesB as text
%        str2double(get(hObject,'String')) returns contents of NparticlesB as a double
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function NparticlesB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NparticlesB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function xmaxB_Callback(hObject, eventdata, handles)
% hObject    handle to xmaxB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of xmaxB as text
%        str2double(get(hObject,'String')) returns contents of xmaxB as a double
TsliderB_Callback(handles.TsliderB, eventdata, handles);


%% --- Executes during object creation, after setting all properties.
function xmaxB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to xmaxB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% --- Executes on button press in showLevelsA.
function showLevelsA_Callback(hObject, eventdata, handles)
% hObject    handle to showLevelsA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showLevelsA
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes on button press in showLevelsB.
function showLevelsB_Callback(hObject, eventdata, handles)
% hObject    handle to showLevelsB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showLevelsB
TsliderB_Callback(handles.TsliderB, eventdata, handles);


%%
function dq_Callback(hObject, eventdata, handles)
% hObject    handle to dq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dq as text
%        str2double(get(hObject,'String')) returns contents of dq as a double


%% --- Executes during object creation, after setting all properties.
function dq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% --- Executes on button press in push_dq_left.
function push_dq_left_Callback(hObject, eventdata, handles)
% hObject    handle to push_dq_left (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get the current energies.
EtotA = str2num(get(handles.totalU,'String'));
EtotB = str2num(get(handles.totalUB,'String'));
dq = str2num(get(handles.dq,'String'));

% Make sure that there is enough energy to move
if dq > EtotB
    errordlg(sprintf('You tried to move %f kJ, but there is only %f kJ in system B\n',...
        dq,EtotB),'Too large dq!');
    return;
end

% Get temperatures of the systems 
TA = get(handles.TsliderA,'Value');
TB = get(handles.TsliderB,'Value');

% Get energy levels and their degenaracies from axes data
M = get(handles.figure1,'UserData');
ElevA = M.A.Ei;
ElevB = M.B.Ei;
giA = M.A.gi;
giB = M.B.gi;

% Calculate energy of each system after movement of dq.
EtotA = EtotA + dq;
EtotB = EtotB - dq;
EtotA = EtotA*1000;
EtotB = EtotB*1000;
NA = str2num(get(handles.NparticlesA,'String'));
NB = str2num(get(handles.NparticlesB,'String'));

% Define function used for minimization (fitting for energy)
chi2fun = @(T,Etot,Ei,gi,N) (Etot-sum(Ei*8.3145*N.*boltzfun(T,Ei,gi)))^2;

% Find temperature that matches total energy for each of the systems
% Determine guess for T by assuming a Cv of R J/(K mol).
Ttmp = TA+1000*dq/(8.3145*NA);
if Ttmp > 0
    TA = Ttmp;
end
Ttmp = TB-1000*dq/(8.3145*NB);
if Ttmp > 0
    TB = Ttmp;
end
ToptA = fminsearch(@(T) chi2fun(T,EtotA,ElevA,giA,NA),TA);
if ToptA > get(handles.TsliderA,'Max')
    errordlg(sprintf('Temperature in A reached maximum. Try a smaller dq!'),...
        'Too high T!');
    return;
end
ToptB = fminsearch(@(T) chi2fun(T,EtotB,ElevB,giB,NB),TB);


% Set temperatures and update plots
set(handles.TsliderA,'Value',ToptA);
set(handles.TsliderB,'Value',ToptB);
TsliderA_Callback(handles.TsliderA, eventdata, handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


%% --- Executes on button press in push_dq_right.
function push_dq_right_Callback(hObject, eventdata, handles)
% hObject    handle to push_dq_right (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get the current energies.
EtotA = str2num(get(handles.totalU,'String'));
EtotB = str2num(get(handles.totalUB,'String'));
dq = str2num(get(handles.dq,'String'));

% Make sure that there is enough energy to move
if dq > EtotA
    errordlg(sprintf('You tried to move %f kJ, but there is only %f kJ in system A\n',...
        dq,EtotA),'Too large dq!');
    return;
end

% Get temperatures of the systems 
TA = get(handles.TsliderA,'Value');
TB = get(handles.TsliderB,'Value');

% Get energy levels and their degenaracies from axes data
M = get(handles.figure1,'UserData');
ElevA = M.A.Ei;
ElevB = M.B.Ei;
giA = M.A.gi;
giB = M.B.gi;


% Calculate energy of each system after movement of dq.
EtotA = EtotA - dq;
EtotB = EtotB + dq;
EtotA = EtotA*1000;
EtotB = EtotB*1000;
NA = str2num(get(handles.NparticlesA,'String'));
NB = str2num(get(handles.NparticlesB,'String'));

% Define function used for minimization (fitting for energy)
chi2fun = @(T,Etot,Ei,gi,N) (Etot-sum(Ei*8.3145*N.*boltzfun(T,Ei,gi)))^2;

% Find temperature that matches total energy for each of the systems
% Determine guess for T by assuming a Cv of R J/(K mol).
Ttmp = TA-1000*dq/(8.3145*NA);
if Ttmp > 0
    TA = Ttmp;
end
Ttmp = TB+1000*dq/(8.3145*NB);
if Ttmp > 0
    TB = Ttmp;
end
ToptA = fminsearch(@(T) chi2fun(T,EtotA,ElevA,giA,NA),TA);
ToptB = fminsearch(@(T) chi2fun(T,EtotB,ElevB,giB,NB),TB);
if ToptB > get(handles.TsliderB,'Max')
    errordlg(sprintf('Temperature in B reached maximum. Try a smaller dq!'),...
        'Too high T!');
    return;
end

% Set temperatures and update plots
set(handles.TsliderA,'Value',ToptA);
set(handles.TsliderB,'Value',ToptB);
TsliderA_Callback(handles.TsliderA, eventdata, handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


%% --------------------------------------------------------------------
function PrintPreviewMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintPreviewMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printpreview(handles.figure1)

%% --- Executes on button press in pRelativeA.
function pRelativeA_Callback(hObject, eventdata, handles)
% hObject    handle to pRelativeA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of pRelativeA
TsliderA_Callback(handles.TsliderA, eventdata, handles);


%% --- Executes on button press in pRelativeB.
function pRelativeB_Callback(hObject, eventdata, handles)
% hObject    handle to pRelativeB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of pRelativeB
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes on selection change in systemTypeA.
function systemTypeA_Callback(hObject, eventdata, handles)
% hObject    handle to systemTypeA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns systemTypeA contents as cell array
%        contents{get(hObject,'Value')} returns selected item from systemTypeA
switch get(hObject,'Value')
    case 1
        set(handles.rotMolA,'Visible','off');
        set(handles.textNsublevelsA,'Visible','off');
        set(handles.NsublevelsA,'Visible','off');
        set(handles.textEdiffA,'Visible','on');
        set(handles.textEdiffSubA,'Visible','off');
        set(handles.EdiffA,'Visible','on');
        set(handles.EdiffSubA,'Visible','off');
        set(handles.unitEdiffA,'Visible','on');
        set(handles.unitEdiffSubA,'Visible','off');
        set(handles.EdiffA,'String','10');
    case 2
        set(handles.rotMolA,'Visible','off');
        set(handles.textNsublevelsA,'Visible','on');
        set(handles.NsublevelsA,'Visible','on');
        set(handles.textEdiffA,'Visible','on');
        set(handles.textEdiffSubA,'Visible','on');
        set(handles.EdiffA,'Visible','on');
        set(handles.EdiffSubA,'Visible','on');
        set(handles.unitEdiffA,'Visible','on');
        set(handles.unitEdiffSubA,'Visible','on');
        set(handles.EdiffA,'String','200');
    case 3
        set(handles.textNsublevelsA,'Visible','off');
        set(handles.NsublevelsA,'Visible','off');
        set(handles.textEdiffA,'Visible','off');
        set(handles.textEdiffSubA,'Visible','off');
        set(handles.EdiffSubA,'Visible','off');
        set(handles.unitEdiffA,'Visible','off');
        set(handles.unitEdiffSubA,'Visible','off');
        set(handles.EdiffA,'Visible','off');
        set(handles.rotMolA,'Visible','on');
end        
calculate_ElevelsA(handles);
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function systemTypeA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to systemTypeA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in systemTypeB.
function systemTypeB_Callback(hObject, eventdata, handles)
% hObject    handle to systemTypeB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns systemTypeB contents as cell array
%        contents{get(hObject,'Value')} returns selected item from systemTypeB
switch get(hObject,'Value')
    case 1
        set(handles.rotMolB,'Visible','off');
        set(handles.textNsublevelsB,'Visible','off');
        set(handles.NsublevelsB,'Visible','off');
        set(handles.textEdiffB,'Visible','on');
        set(handles.textEdiffSubB,'Visible','off');
        set(handles.EdiffB,'Visible','on');
        set(handles.EdiffSubB,'Visible','off');
        set(handles.unitEdiffB,'Visible','on');
        set(handles.unitEdiffSubB,'Visible','off');
        set(handles.EdiffB,'String','10');
    case 2
        set(handles.rotMolB,'Visible','off');
        set(handles.textNsublevelsB,'Visible','on');
        set(handles.NsublevelsB,'Visible','on');
        set(handles.textEdiffB,'Visible','on');
        set(handles.textEdiffSubB,'Visible','on');
        set(handles.EdiffB,'Visible','on');
        set(handles.EdiffSubB,'Visible','on');
        set(handles.unitEdiffB,'Visible','on');
        set(handles.unitEdiffSubB,'Visible','on');
        set(handles.EdiffB,'String','200');
    case 3
        set(handles.textNsublevelsB,'Visible','off');
        set(handles.NsublevelsB,'Visible','off');
        set(handles.textEdiffB,'Visible','off');
        set(handles.textEdiffSubB,'Visible','off');
        set(handles.EdiffSubB,'Visible','off');
        set(handles.unitEdiffB,'Visible','off');
        set(handles.unitEdiffSubB,'Visible','off');
        set(handles.EdiffB,'Visible','off');
        set(handles.rotMolB,'Visible','on');
end        
calculate_ElevelsB(handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function systemTypeB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to systemTypeB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NsublevelsA_Callback(hObject, eventdata, handles)
% hObject    handle to NsublevelsA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NsublevelsA as text
%        str2double(get(hObject,'String')) returns contents of NsublevelsA as a double
calculate_ElevelsA(handles);
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function NsublevelsA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NsublevelsA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function EdiffSubA_Callback(hObject, eventdata, handles)
% hObject    handle to EdiffSubA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of EdiffSubA as text
%        str2double(get(hObject,'String')) returns contents of EdiffSubA as a double
calculate_ElevelsA(handles);
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function EdiffSubA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdiffSubA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function NsublevelsB_Callback(hObject, eventdata, handles)
% hObject    handle to NsublevelsB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NsublevelsB as text
%        str2double(get(hObject,'String')) returns contents of NsublevelsB as a double
calculate_ElevelsB(handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function NsublevelsB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NsublevelsB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function EdiffSubB_Callback(hObject, eventdata, handles)
% hObject    handle to EdiffSubB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of EdiffSubB as text
%        str2double(get(hObject,'String')) returns contents of EdiffSubB as a double
calculate_ElevelsB(handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function EdiffSubB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdiffSubB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% Define functions for Boltzmann dist and partition function
function [p, q] = boltzfun(T,Ei,gi)
p = gi.*exp(-Ei/T);
q = sum(p);
p = p./q;

function calculate_ElevelsA(handles)
% Set level energies and degeneracies
% Calculate on 10000 levels (user determines how many that are plotted)
M = get(handles.figure1,'UserData');
if isstruct(M)
    if isfield(M,'A')
        M = rmfield(M,'A');
    end
end
M.A.levels = 0:10000;
switch get(handles.systemTypeA,'Value')
    case 1
        M.A.Ediff = str2num(get(handles.EdiffA,'String'));
        M.A.Ei = M.A.levels*M.A.Ediff;
        % EdiffSubA is degeneracy in this case.
        M.A.gi = ones(size(M.A.Ei));
    case 2
        M.A.Ediff = str2num(get(handles.EdiffA,'String'));
        M.A.EdiffSub = str2num(get(handles.EdiffSubA,'String'));
        M.A.Nsublevels = str2num(get(handles.NsublevelsA,'String'));
        M.A.Ei = zeros(size(M.A.levels));
        mainLev = 1:M.A.Nsublevels:length(M.A.levels);
        for i=1:length(mainLev),
            M.A.Ei(mainLev(i)) = (i-1)*M.A.Ediff;
            for j=1:M.A.Nsublevels-1,
                M.A.Ei(mainLev(i)+j) = M.A.Ei(mainLev(i))+j*M.A.EdiffSub;
            end
        end
        M.A.gi = ones(size(M.A.Ei));
    case 3
        switch get(handles.rotMolA,'Value')
            case 1
                M.A.theta = 0.116;  % Br2
                M.A.sig = 2;
            case 2
                M.A.theta = 2.07;   % O2
                M.A.sig = 2;
            case 3
                M.A.theta = 15.02;  % HCl
                M.A.sig = 2;
            case 4
                M.A.theta = 85.3;   % H2
                M.A.sig = 2;
        end
        M.A.Ei = M.A.levels.*(M.A.levels+1).*M.A.theta;
        M.A.gi = ones(size(M.A.Ei));
        M.A.gi(2:length(M.A.gi)) = (2*M.A.levels(2:length(M.A.gi))+1)/M.A.sig;
end        
set(handles.figure1,'UserData',M);

function calculate_ElevelsB(handles)
% Set level energies and degeneracies
% Calculate on 10000 levels (user determines how many that are plotted)
M = get(handles.figure1,'UserData');
if isstruct(M)
    if isfield(M,'B')
        M = rmfield(M,'B');
    end
end
M.B.levels = 0:10000;
switch get(handles.systemTypeB,'Value')
    case 1
        M.B.Ediff = str2num(get(handles.EdiffB,'String'));
        M.B.Ei = M.B.levels*M.B.Ediff;
        % EdiffSubA is degeneracy in this case.
        M.B.gi = ones(size(M.B.Ei));
    case 2
        M.B.Ediff = str2num(get(handles.EdiffB,'String'));
        M.B.EdiffSub = str2num(get(handles.EdiffSubB,'String'));
        M.B.Nsublevels = str2num(get(handles.NsublevelsB,'String'));
        M.B.Ei = zeros(size(M.B.levels));
        mainLev = 1:M.B.Nsublevels:length(M.B.levels);
        for i=1:length(mainLev),
            M.B.Ei(mainLev(i)) = (i-1)*M.B.Ediff;
            for j=1:M.B.Nsublevels-1,
                M.B.Ei(mainLev(i)+j) = M.B.Ei(mainLev(i))+j*M.B.EdiffSub;
            end
        end
        M.B.gi = ones(size(M.B.Ei));
    case 3
        switch get(handles.rotMolB,'Value')
            case 1
                M.B.theta = 0.116;  % Br2
                M.B.sig = 2;
            case 2
                M.B.theta = 2.07;   % O2
                M.B.sig = 2;
            case 3
                M.B.theta = 15.02;  % HCl
                M.B.sig = 2;
            case 4
                M.B.theta = 85.3;   % H2
                M.B.sig = 2;
        end
        M.B.Ei = M.B.levels.*(M.B.levels+1).*M.B.theta;
        M.B.gi = ones(size(M.B.Ei));
        M.B.gi(2:length(M.B.gi)) = (2*M.B.levels(2:length(M.B.gi))+1)/M.B.sig;
end        
set(handles.figure1,'UserData',M);



%% --- Executes on selection change in rotMolA.
function rotMolA_Callback(hObject, eventdata, handles)
% hObject    handle to rotMolA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns rotMolA contents as cell array
%        contents{get(hObject,'Value')} returns selected item from rotMolA
calculate_ElevelsA(handles);
TsliderA_Callback(handles.TsliderA, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function rotMolA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rotMolA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% --- Executes on selection change in rotMolB.
function rotMolB_Callback(hObject, eventdata, handles)
% hObject    handle to rotMolB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns rotMolB contents as cell array
%        contents{get(hObject,'Value')} returns selected item from rotMolB
calculate_ElevelsB(handles);
TsliderB_Callback(handles.TsliderB, eventdata, handles);


% --- Executes during object creation, after setting all properties.
function rotMolB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rotMolB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% --------------------------------------------------------------------
function PrintFileMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintFileMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname, filterindex] = uiputfile( ...
   {'*.pdf', 'pdf (*.pdf)';
    '*.jpeg',  'jpeg (*.jpeg)'; ...
    '*.tiff','tiff (*.tiff)'}, ...
    'Save as');

if isequal(filename,0) || isequal(pathname,0)
   return;
end

[tmp, fname, fsuf] = fileparts(filename);

switch filterindex
    case 1
        fs = '-dpdf';
        suf = '.pdf';
    case 2
        fs = '-djpeg';
        suf = '.jpeg';
    case 3
        fs = '-dtiff';
        suf = '.tiff';
end

if isempty(fsuf), fsuf = suf; end
fname = fullfile(pathname,[fname,fsuf]);
print(fs,fname);




